/* helper class to carry coordinates */

import java.util.*;
import java.lang.*;

public class Coords {
	public int x;
	public int y;

	public Coords ( Coords dup ) { this.x = dup.x; this.y = dup.y; }

	public Coords ( int x, int y ) { this.x = x; this.y = y; }

	public int hashcode() { return y * 100000 + x; }

	public boolean equals ( int x, int y ) { 
		return this.x == x && this.y == y;
	}

	public boolean equals ( Coords that ) {
		return this.x == that.x && this.y == that.y;
	}

	public void setPosition ( int x, int y ) {
		this.x = x;
		this.y = y;
	}

	public void setPosition ( Coords that ) {
		this.x = that.x;
		this.y = that.y;
	}

	public void move ( String direction ) {
        switch ( direction.charAt(0) ) {
			case 'N':
				y++;
				break;
			case 'S':
				y--;
				break;
			case 'W':
				x--;
				break;
			case 'E':
				x++;
				break;
		}
	}

	public int distFrom ( Coords there ) {
		return Math.abs( this.x - there.x) + Math.abs( this.y - there.y );
	}

	public String directionTo ( Coords there ) {
		int deltaX = there.x - this.x;
		int deltaY = there.y - this.y;

		if ( deltaX == 1 ) 
			return "E";
		if ( deltaX == -1 )
			return "W";
		if ( deltaY == 1 )
			return "N";
		if ( deltaY == -1 ) 
			return "S";

		return "";
	}

	public String toString() {
		return "(" + x +", " + y + ")";
	}

}
