// ICFPPack to store package information 

import java.util.*;
import java.lang.*;

public class ICFPPack {
	private Integer packID;
	private Coords loc;
	private Coords dest;
	private boolean locCert;
	private boolean carried;
	private int weight;


	public ICFPPack ( Integer id ) {
		packID = id;
		locCert = false;
		carried = false;
		loc = new Coords( -1, -1 );
		dest = new Coords( -1, -1 );
		weight = -1;
	}

	public ICFPPack ( Integer id, Coords newLoc, Coords newDest, int newWeight ) {
		packID = id;
		loc = newLoc;
		dest = newDest;
		weight = newWeight;
		locCert = true;
		carried = false;
	}

	public boolean locValid() { return loc.x > 0; }

	public boolean destValid() { return dest.x > 0; }

	public boolean locCertain() { return locCert; }

	public boolean weightValid() { return weight > 0; }

	public boolean isCarried() { return carried; }

	public void clearLoc() { loc.x = -1; }

	public void setCarry ( boolean newval ) { carried = newval; }

	public void setLoc ( Coords newLoc, boolean cert ) {
		loc = newLoc;
		locCert = cert;
	}

	public Coords getDest() { return dest; }
	
	public Coords getLoc() { return loc; }

	public int getWeight() { return weight; }

	public Integer getID() { return packID; }

}
