import java.util.*;
import java.lang.*;

public class Move {

/*
    * Bid
    * Move direction
    * Pick list of package IDs
    * Drop list of package IDs

    * A direction is one of: N E S W
    * A package ID is an integer
    * A list of package IDs consists of integers separated by space

Example: Here are some example commands:
1 Move N
200 Pick 17 89
29 Move W
-8 Move S
57 Drop 11
1 Drop
*/

  int bid;
  String direction;
  Vector pickList;
  Vector dropList;

  public Move() {
     bid  = 1;
     direction = "";
     pickList = null;
     dropList = null;
  }

  public Move( int bid, String direction, Vector pickList, Vector dropList ) {
     this.bid = bid;
     this.direction = direction;
     this.pickList = pickList;
     this.dropList = dropList;
  }

  public void setBid( int bid ) { this.bid=bid;}
  public void setDirection( String direction ) { this.direction=direction; }
  public void addToPickList( Integer pack ) {
     if (pickList == null ) pickList = new Vector();
     pickList.addElement( pack );
  }
  public void setPickList( Vector pickList ) { this.pickList = pickList; }

  public int getBid() { return bid; }
  public void addToDropList( Integer pack ) {
     if (dropList == null ) dropList = new Vector();
     dropList.addElement( pack );
  }
  public void setDropList( Vector dropList ) { this.dropList = dropList; }

  public String toString() {
      StringBuffer move = new StringBuffer( ""+bid );
      if (direction != "" ) {
         move.append(" Move ");
         move.append( direction );
      } else if ( pickList != null ) {
         move.append( " Pick");
		ICFPContest.log("Building a picklist of size "+pickList.size(),5);
         for (Enumeration ep =pickList.elements(); ep.hasMoreElements() ; )
		 {
			 Integer foo = (Integer) ep.nextElement();
			 move.append( " "+ foo.toString());
         }
      } else if ( dropList != null ) {
         move.append( " Drop" );
		ICFPContest.log("Building a droplist of size "+dropList.size(),5);
         for (Enumeration ed = dropList.elements(); ed.hasMoreElements(); ) {
            move.append( " "+(String) ed.nextElement().toString());
         }
      }
      return ( move.toString());
   }

}
