

import java.util.*;
import java.lang.*;
import java.lang.Math.*;

public class Path {

  private static Coords Boardsize;


 public static Vector getPathTo( Coords src, Coords dest ) {
		return getPathTo( src.x, src.y, dest.x, dest.y );
}

  public static boolean canMove( int x, int y )
  {
     char loc =  ICFPContest.mapData[x][y];
     ICFPContest.log("checking "+x+","+y+", found "+ICFPContest.mapData[x][y], 6 );
		 if ( loc == '.' ) return true;
     if ( loc == '@' ) return true;
		 return false;
  }


  public static Vector getPathTo( int from_x, int from_y, int to_x, int to_y )
  {

		Vector path = new Vector();

		int x= from_x;
		int y = from_y;
    	int dx = 1;
		int dy = 1;
		int dist_x, dist_y;
		boolean forever = true;
		boolean moved = false;
		Coords blockd = null;
    	Coords door= null;
    	Boardsize = new Coords( ICFPContest.mapWidth,ICFPContest.mapHeight);
    	Vector part = null;

   	do {
        if (x != to_x ) {
			moved = false;
   	    	blockd = isBlockX(x, y, to_x );
			if  ( blockd != null)  {
            	if ( to_x > x ) dx = 1;
            	else dx = -1;
            	if ( to_y > y ) dy = 1;
			    else if ( to_y< y ) dy = -1;
            	else dy = 0;
		        door = findDoorAtX( blockd.x, blockd.y, dy );
            	if ( door != null ) {
            	    part = getPathTo( x, y, x, door.y );
            	    if ((part != null) && (part.size() > 0 )) {
 		           	    path.addAll( path);
                	    ICFPContest.log( "built path from "+x+","+y+" to "+x+","+door.y, 5 );
					    y = door.y;
					    moved = true;
					}
				} if ( !moved ) {
                	dy = -dy;
		            door = findDoorAtX( blockd.x, blockd.y, dy );
                	if ( door != null ) {
                	   part = getPathTo(x, y, x, door.y);
					   if ((part != null) && (part.size() > 0 )){
					      path.addAll(part );
                	      ICFPContest.log( "built path from "+x+","+y+" to "+x+","+door.y, 5 );
				          y = door.y;
				          moved = true;
				   		}
				    } if (!moved) {
				        ICFPContest.log( ("Backing up from "+x+", "+y+" to get to "+to_x+", "+to_y), 3);
                   		if ( path.size() ==0 ) return null;
                   		path.removeElementAt( path.size()-1);
                   		Coords back  = (Coords) path.lastElement();
                   		x = back.x;
                   		y = back.y;
                	}
				}
			} else { // no blocks move to_x
             	if ( to_x > x )
             	  dx = 1;
             	else if ( to_x< x )
             	  dx = -1;

            	addToPath( path, x , y, to_x, y, dx, 0, true );
            	ICFPContest.log( "built path from "+x+","+y+" to "+to_x+","+y, 5 );
            	x = to_x;
          	}
        } // at to_x check y
        if ( y != to_y ) {
			moved = false;
			blockd = isBlockY( x, y, to_y );
			if ( blockd != null ) {
          		if ( to_y > y ) dy = 1;
             	else dy = -1;
            	if ( to_x > x ) dx = 1;
             	else dx = -1;
		     	door = findDoorAtY( blockd.x, blockd.y, dx );
			 	if ( door != null ) {
			     	part = getPathTo( x, y, door.x, y );
			     	if ((part != null) && (part.size() > 0 )) {
						path.addAll( part );
                		ICFPContest.log( "built path from "+x+","+y+" to "+door.x+","+y, 5 );
			 			x = door.x;
			 			moved = true;
					}
			 	} if (!moved) {
        			dx = -dx;
             		door = findDoorAtY( blockd.x, blockd.y, dx );
 			 		if ( door != null ) {
						part = getPathTo( x, y, door.x, y);
						if ((part != null) && (part.size() > 0 )) {
							path.addAll(part);
                			ICFPContest.log( "built path from "+x+","+y+" to "+door.x+","+y, 5 );
			    			x = door.x;
			    			moved =true;
						}
             		} if(!moved) {
			    		ICFPContest.log( ("Backing up from "+x+", "+y+" to get to "+to_x+", "+to_y), 3);
                		if ( path.size() ==0 ) return null;
                		Coords back  = (Coords) path.lastElement();
                		x = back.x;
                		y = back.y;
             		}
         		}
	 		} else {// no blocks, going to_y
         		if ( y > to_y )
         			dy = -1;
         		else
         		   dy = 1;
         		addToPath( path,x, y, x, to_y, 0, dy, false);
         		ICFPContest.log( "built path from "+x+","+y+" to "+x+","+to_y, 5 );
         		y = to_y;
     		}
  		}
	} while ( blockd != null )  ;
		dist_x = to_x - x;
		dist_y = to_y - y;
		if ( dist_x < 0 )  dx = -1;
		else if (dist_x > 0 ) dx=1;
    	else dx=0;
		if ( dist_y < 0 ) dy = -1;
		else if ( dist_y > 0 )dy = -1;
    	else dy = 0;
    	if (( dx != 0 )|| (dy != 0) ) {
		   if ( !addToPath(path, x, y, to_x, to_y, dx, dy, Math.abs(dist_x)>Math.abs(dist_y)))
//				ICFPContest.log( ("No way from "+x+", "+y+" to "+to_x+", "+to_y), 3);
     		;
    	}
		return path;
	}


	private static boolean addToPath( Vector ppath,
														 int x, int y, 				// from
														 int to_x, int to_y, 	// destination
														 int dx, int dy,      // -1, 0, 1
														 boolean xdir )			  // try x direction

	{
    	ICFPContest.log("building path from "+x+","+y+" to "+to_x+","+to_y, 5);
    	if  ( xdir && ( dx!= 0 ) && canMove( x+dx, y )) {
    		ICFPContest.log( "Adding element "+(x+dx)+","+y, 5);
			ppath.addElement( (Object) new Coords(x+dx, y ));
 		 	if ( x+dx != to_x ) {
		 		if ( addToPath( ppath, x+dx, y, to_x, to_y, dx, dy, true )) return true;
  		 	}else {
		     	if ( y == to_y ) return true;
			 	if ( addToPath( ppath, x+dx, y, to_x, to_y,  dx, dy, false ) ) return true;
		 	}
	  	} else if ( (dy!=0 ) && canMove( x, y+dy )) {
         	ICFPContest.log( "Adding element "+x+","+(y+dy), 5);
		 	ppath.addElement( (Object) new Coords( x, y+dy ));
		 	if ( y+dy != to_y ) {
			 	if ( addToPath( ppath, x, y+dy, to_x, to_y, dx, dy, false ) ) return true;
		 	} else {
		  	 	if ( x == to_x ) return true;
		 	 	if ( addToPath( ppath, x, y+dy, to_x, to_y, dx, dy, true ) ) return true;
		 	}
	  	} else {
			if ( ppath.size()>0 )  {
	   		   ppath.removeElementAt( ppath.size()-1 );
         	   ICFPContest.log(" cant move forward, removing element ", 5);
		}
		    return false;
      	}
      	return false;

	}

	public static Coords isBlockX( int x, int y, int to_x )
	{
     	ICFPContest.log("check for block from x="+x+","+y+" along x "+to_x, 5 );
		int xi,  dx;

     	if ( to_x > x )  {
			dx = 1;
		} else if ( to_x< x ) {
			dx = -1;
		} else {
			return null; // we're already there
		}
		for ( xi = x; xi != to_x; xi+=dx ) {
		    if ( !canMove( xi, y )) {
            	ICFPContest.log( "found block at "+xi, 5 );
            	return ( new Coords( xi, y ));
         	}
      	}
      	ICFPContest.log("no block", 5);
		return (null);
	}

    public static Coords isBlockY( int x, int y,  int to_y )
	{

		int yi, dy;
      	ICFPContest.log("checking for block at "+x+","+y+" along y to "+to_y, 5 );

      	if ( to_y > y )  {
			dy = 1;
		} else if ( to_y< y ) {
			dy = -1;
		} else {
			return null; // we're already there
		}
		for ( yi = y; yi != to_y; yi += dy ) {
			if (!canMove( x, yi )) {
        		ICFPContest.log("found block at "+yi, 5 );
        		return ( new Coords( x, yi ));
			}
      	}
      	ICFPContest.log("no block", 5);
		return null ;
  }


 public static Coords findDoorAtX( int wall_x, int wall_y, int inc )
{
	int dy=inc;
	while( (wall_y + dy > 0 ) && (wall_y+dy < Boardsize.y)) {
    	if ( canMove( wall_x, wall_y+dy )) {
    		ICFPContest.log("found door at "+ wall_x+", "+(wall_y+dy), 5 );
            return ( new Coords( wall_x, wall_y + dy ));
        }
        dy += inc;
	}
    ICFPContest.log("no door found", 5);
	return null;
}

public static Coords findDoorAtY( int wall_x, int wall_y, int inc )
{
	 int dx=inc;
	 while ( ( wall_x+dx > 0 ) && ( wall_x+dx < Boardsize.x )) {
		if ( canMove( wall_x+dx, wall_y )) {
            ICFPContest.log("found door at "+ (wall_x+dx)+", "+wall_y, 5 );
            return ( new Coords( wall_x+dx, wall_y ));
        }
      	dx += inc;
	}
    ICFPContest.log("No door found", 5);
    return null;
}

}








